with AUnit.Assertions; 
with Crypto.Symmetric.Blockcipher_AES128;
with Crypto.Types;

package body Test.AES128 is 
   use Crypto.Types;
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
-------------------------------- Type - Declaration --------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
   
   Plaintext: constant B_Block128 := (16#00#, 16#11#, 16#22#, 16#33#, 16#44#,
                              			   16#55#, 16#66#, 16#77#, 16#88#, 16#99#,
                              			   16#aa#, 16#bb#, 16#cc#, 16#dd#, 16#ee#,
                              			   16#ff#);
    
    Ciphertext: B_Block128;
    
    Temp: B_Block128;

	Key: B_Block128;
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------- Register AES128 Test -------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

	procedure Register_Tests(T : in out AES_Test) is
		use Test_Cases.Registration;
	begin
		Register_Routine(T, AES128_Test1'Access,"AES128_Test.");
	end Register_Tests;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
--------------------------------- Name AES128 Test ---------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

	function Name(T : AES_Test) return Test_String is
	begin
		return new String'("AES128 Test");
	end Name;
   
------------------------------------------------------------------------------------
------------------------------------ Start Test ------------------------------------
------------------------------------------------------------------------------------
--------------------------------------- Test ---------------------------------------
------------------------------------------------------------------------------------
	
	procedure AES128_Test1(T: in out Test_Cases.Test_Case'Class) is
	   use AUnit.Assertions; 
	   use Crypto.Symmetric.Blockcipher_AES128;
	begin
	   
	   Ciphertext := (16#69#, 16#c4#, 16#e0#, 16#d8#, 16#6a#, 16#7b#, 16#04#,
			  16#30#, 16#d8#, 16#cd#, 16#b7#, 16#80#, 16#70#, 16#b4#,
			  16#c5#, 16#5a#);
	   
		Key := (16#00#, 16#01#, 16#02#, 16#03#, 16#04#, 16#05#,
			16#06#, 16#07#, 16#08#, 16#09#, 16#0a#, 16#0b#,
			16#0c#, 16#0d#, 16#0e#, 16#0f#);
		
		
		Prepare_Key(Key);
		
		Encrypt(Plaintext, Temp);
		
		Assert(Temp = Ciphertext, "AES-Encryption failed.");

		Decrypt(Ciphertext, Temp);

		Assert(Temp = Plaintext, "AES-Decryption failed.");

	end AES128_Test1;

------------------------------------------------------------------------------------

end Test.AES128;
