with AUnit.Assertions; 
with Crypto.Symmetric.Blockcipher_AES256;
with Crypto.Types;

package body Test.AES256 is 
   use Crypto.Types;
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
-------------------------------- Type - Declaration --------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
   
   Plaintext: B_Block128 := (16#00#, 16#11#, 16#22#, 16#33#, 16#44#,
                              16#55#, 16#66#, 16#77#, 16#88#, 16#99#,
                              16#aa#, 16#bb#, 16#cc#, 16#dd#, 16#ee#,
                              16#ff#);
    
    Ciphertext: B_Block128;
    
    Temp: B_Block128;

    Key: B_Block256;
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------- Register AES256 Test -------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

	procedure Register_Tests(T : in out AES_Test) is
		use Test_Cases.Registration;
	begin
		Register_Routine(T, AES256_Test1'Access,"AES256_Test.");
	end Register_Tests;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
--------------------------------- Name AES256 Test ---------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

	function Name(T : AES_Test) return Test_String is
	begin
		return new String'("AES256 Test");
	end Name;
   
------------------------------------------------------------------------------------
------------------------------------ Start Test ------------------------------------
------------------------------------------------------------------------------------
--------------------------------------- Test ---------------------------------------
------------------------------------------------------------------------------------
   
	procedure AES256_Test1(T: in out Test_Cases.Test_Case'Class) is
	   use AUnit.Assertions; 
	   use Crypto.Symmetric.Blockcipher_AES256;
	begin
	   Ciphertext := (16#8e#, 16#a2#, 16#b7#, 16#ca#, 16#51#, 16#67#,
			  16#45#, 16#bf#, 16#ea#, 16#fc#, 16#49#, 16#90#,
			  16#4b#, 16#49#, 16#60#, 16#89#);
	   
	   Key:= (16#00#, 16#01#, 16#02#, 16#03#, 16#04#, 16#05#,
		  16#06#, 16#07#, 16#08#, 16#09#, 16#0a#, 16#0b#,
		  16#0c#, 16#0d#, 16#0e#, 16#0f#, 16#10#, 16#11#,
		  16#12#, 16#13#, 16#14#, 16#15#, 16#16#, 16#17#,
		  16#18#, 16#19#, 16#1a#, 16#1b#, 16#1c#, 16#1d#,
		  16#1e#, 16#1f#);
	   
	   Prepare_Key(Key);
	   
	   Encrypt(Plaintext, Temp);
	   
	   Assert(Temp = Ciphertext, "AES-Encryption failed.");

	   Decrypt(Ciphertext, Temp);
	   
	   Assert(Temp = Plaintext, "AES-Decryption failed.");
	   
	end AES256_Test1;

------------------------------------------------------------------------------------

end Test.AES256;

