with AUnit.Assertions;
with Crypto.Symmetric.Oneway_Blockcipher_Twofish128;
with Crypto.Types;

package body Test.Twofish128_Oneway is
use Crypto.Types;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
-------------------------------- Type - Declaration --------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

   Plaintext: B_Block128 := (others => 0);
   Key: B_Block128 := (others => 0);
   Ciphertext: B_Block128 := (16#5D#, 16#9D#, 16#4E#, 16#EF#, 16#FA#,
                              16#91#, 16#51#, 16#57#, 16#55#, 16#24#,
                              16#F1#, 16#15#, 16#81#, 16#5A#, 16#12#,
                              16#E0#);
   PT: B_Block128 := Plaintext;
   CT: B_Block128;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
---------------------------- Register Twofish128 Test 1 ----------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

	procedure Register_Tests(T : in out Twofish_Test) is
		use Test_Cases.Registration;
	begin
		Register_Routine(T, Twofish128_Oneway_Test1'Access,"Twofish128 Known Answer Test");

	end Register_Tests;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------ Name Twofish128 Test ------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

	function Name(T : Twofish_Test) return Test_String is
	begin
		return new String'("Twofish128 Test");
	end Name;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------ Start Tests -----------------------------------
------------------------------------------------------------------------------------
-------------------------------------- Test 1 --------------------------------------
------------------------------------------------------------------------------------

   procedure Twofish128_Oneway_Test1(T : in out Test_Cases.Test_Case'Class) is
      use AUnit.Assertions;
      use Crypto.Symmetric.Oneway_Blockcipher_Twofish128;
   begin
   	   for I in 1 .. 49 loop
   	   	   Prepare_Key(Key);
   	   	   Encrypt(PT, CT);
   	   	   Key := PT;
   	   	   PT  := CT;
   	   end loop;

   	   for I in CT'Range loop
   	   	   Assert(CT(I) = Ciphertext(I), "Twofish128 Known Answer Test");
	   end loop;
   end Twofish128_Oneway_Test1;

------------------------------------------------------------------------------------


end Test.Twofish128_Oneway;
